

   MEMBER('qrafip.clw')                                    ! This is a MEMBER module


   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('QRAFI001.INC'),ONCE        !Local module procedure declarations
                     END


Main PROCEDURE                                             ! Generated from procedure template - Frame

ver                  ULONG                                 !
fecha                STRING(10)                            !
cuit                 DECIMAL(13)                           !
ptovta               ULONG                                 !
tipocomp             ULONG                                 !
nrocmp               DECIMAL(20)                           !
importe              STRING(20)                            !
moneda               STRING(3)                             !
ctz                  STRING(20)                            !
tipoDocRec           ULONG                                 !
nroDocRec            DECIMAL(13)                           !
tipoCodAut           STRING(1)                             !
codAut               DECIMAL(14)                           !
DisplayDayString STRING('Sunday   Monday   Tuesday  WednesdayThursday Friday   Saturday ')
DisplayDayText   STRING(9),DIM(7),OVER(DisplayDayString)
AppFrame             APPLICATION('Process Customer Orders'),AT(,,400,253),FONT('MS Sans Serif',8,COLOR:Black,),STATUS(-1,80,120,45),SYSTEM,MAX,RESIZE,IMM
                       TOOLBAR,AT(0,0,400,75)
                         OLE,AT(214,24,34,13),USE(?OLE),COMPATIBILITY(020H)
                         END
                         BUTTON('Generar QR'),AT(11,7,57,19),USE(?Button1)
                       END
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED                 ! Method added to host embed code
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It's called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  IF NOT INRANGE(AppFrame{Prop:Timer},1,100)
    AppFrame{Prop:Timer} = 100
  END
    AppFrame{Prop:StatusText,3} = CLIP(DisplayDayText[(TODAY()%7)+1]) & ', ' & FORMAT(TODAY(),@D4)
    AppFrame{Prop:StatusText,4} = FORMAT(CLOCK(),@T3)
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Main')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = 1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  OPEN(AppFrame)                                           ! Open window
  SELF.Opened=True
  Do DefineListboxStyle
  INIMgr.Fetch('Main',AppFrame)                            ! Restore window settings from non-volatile store
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Main',AppFrame)                         ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?Button1
        ?OLE{PROP:Create} = 'QRAFIP.QR'
        ?OLE{'ArchivoQR'} = ?OLE{'RutaLibreria'} & 'qr.bmp' ! Admite formatos BMP, PNG y JPG con solo cambiar la extension
      
        ver = 1
        fecha = '2020-12-31'
        cuit = 20939802593
        ptoVta = 2
        tipoComp = 1
        nroCmp = 1
        importe = format(100.01,@n13`2)
        moneda = 'PES'
        ctz = format(1.0,@n13`2)
        tipoDocRec = 80
        nroDocRec = 27929007862
        tipoCodAut = 'E'  ! A = CAEA E = CAE
        codAut = 12345678901234
      
        BIND('ver', ver)
        BIND('fecha', fecha)
        BIND('cuit', cuit)
        BIND('ptoVta', ptoVta)
        BIND('tipoComp', tipoComp)
        BIND('nroCmp', nroCmp)
        BIND('importe', importe)
        BIND('moneda', moneda)
        BIND('ctz', ctz)
        BIND('tipoDocRec', tipoDocRec)
        BIND('nroDocRec', nroDocRec)
        BIND('tipoCodAut', tipoCodAut)
        BIND('codAut', codAut)
      
      
        If ?OLE{'Generar(ver,'&fecha&', &cuit, ptoVta, tipoComp, &nroCmp, &importe,'&moneda&',&ctz, tipoDocRec, &nroDocRec, '&tipoCodAut&', &codAut)'}
          MESSAGE('QR generado con exito en ' & ?OLE{'ArchivoQR'})
        Else
          MESSAGE(?OLE{'ErrorDesc'})
        End
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all window specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF Event:Timer
      AppFrame{Prop:StatusText,3} = CLIP(DisplayDayText[(TODAY()%7)+1]) & ', ' & FORMAT(TODAY(),@D4)
      AppFrame{Prop:StatusText,4} = FORMAT(CLOCK(),@T3)
    ELSE
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

